#include <stdio.h>
#include "glx.h"
#include "x11.h"

glSingle(fd, buf,n)
FD fd;
unsigned char *buf;
int n;
{
    int Request = buf[1];

    fprintf(stdout,"\t.........GLX_REQUEST: %s\n", GLXCommand[Request]);
    if (Verbose < 1)
        return;
    if (Verbose > 1)
        PrintField(SBf, 0, 4, CARD32, "sequence number");

    switch (Request) {

/* Process glRender command */
    case X_GLXRender:
        GLXRender(buf,n);
        break;
    case X_GLXRenderLarge:
        GLXRenderLarge(buf,n);
        break;
  case X_GLXQueryVersion:
    GLXQueryVersion(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLXCreateContext:
    GLXCreateContext(buf,n);
    break;
  case X_GLXDestroyContext:
    GLXDestroyContext(buf,n);
    break;
  case X_GLXMakeCurrent:
    GLXMakeCurrent(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLXIsDirect:
    GLXIsDirect(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLXCopyContext:
    GLXCopyContext(buf,n);
    break;
  case X_GLXWaitGL:
    GLXWaitGL(buf,n);
    break;
  case X_GLXWaitX:
    GLXWaitX(buf,n);
    break;
  case X_GLXSwapBuffers:
    GLXSwapBuffers(buf,n);
    break;
  case X_GLXUseXFont:
    GLXUseXFont(buf,n);
    break;
  case X_GLXCreateGLXPixmap:
    GLXCreateGLXPixmap(buf,n);
    break;
  case X_GLXDestroyGLXPixmap:
    GLXDestroyGLXPixmap(buf,n);
    break;
  case X_GLXGetVisualConfigs:
    GLXGetVisualConfigs(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLXVendorPrivate:
    GLXVendorPrivate(buf,n);
    break;
  case X_GLXVendorPrivateWithReply:
    GLXVendorPrivateWithReply(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_NewList:
    GLXNewList(buf,n);
    break;
  case X_GLsop_EndList:
    GLXEndList(buf,n);
    break;
  case X_GLsop_DeleteLists:
    GLXDeleteLists(buf,n);
    break;
  case X_GLsop_GenLists:
    GLXGenLists(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetLightfv:
    GLXGetLightfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetLightiv:
    GLXGetLightiv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetMapdv:
    GLXGetMapdv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetMapfv:
    GLXGetMapfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetMapiv:
    GLXGetMapiv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetMaterialfv:
    GLXGetMaterialfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetMaterialiv:
    GLXGetMaterialiv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetPixelMapfv:
    GLXGetPixelMapfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetPixelMapuiv:
    GLXGetPixelMapuiv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetPixelMapusv:
    GLXGetPixelMapusv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexEnvfv:
    GLXGetTexEnvfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexEnviv:
    GLXGetTexEnviv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexGendv:
    GLXGetTexGendv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexGenfv:
    GLXGetTexGenfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexGeniv:
    GLXGetTexGeniv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexParameterfv:
    GLXGetTexParameterfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexParameteriv:
    GLXGetTexParameteriv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexLevelParameterfv:
    GLXGetTexLevelParameterfv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexLevelParameteriv:
    GLXGetTexLevelParameteriv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_IsEnabled:
    GLXIsEnabled(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_IsList:
    GLXIsList(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_FeedbackBuffer:
    GLXFeedbackBuffer(buf,n);
    break;
  case X_GLsop_Finish:
    GLXFinish(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_Flush:
    GLXFlush(buf,n);
    break;
  case X_GLsop_GetBooleanv:
    GLXGetBooleanv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetClipPlane:
    GLXGetClipPlane(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetDoublev:
    GLXGetDoublev(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetError:
    GLXGetError(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetFloatv:
    GLXGetFloatv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetIntegerv:
    GLXGetIntegerv(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetString:
    GLXGetString(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_PixelStoref:
    GLXPixelStoref(buf,n);
    break;
  case X_GLsop_PixelStorei:
    GLXPixelStorei(buf,n);
    break;
  case X_GLsop_RenderMode:
    GLXRenderMode(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_SelectBuffer:
    GLXSelectBuffer(buf,n);
    break;
  case X_GLsop_GetPolygonStipple:
    GLXGetPolygonStipple(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_GetTexImage:
    GLXGetTexImage(buf,n);
    GLXReplyExpected(fd, Request);
    break;
  case X_GLsop_ReadPixels:
    GLXReadPixels(buf,n);
    GLXReplyExpected(fd, Request);
    break;
    default:
        DumpHexBuffer(buf, n);
        fprintf(stdout, "\n");
    }
}

void
gl_decode_reply(Request, buf, n)
int Request;
unsigned char *buf;
int n;
{
    Request -= 1000;
    fprintf(stdout,"\t\t\t\t\t...........GLX_REPLY: %s\n", GLXCommand[Request]);
    if (Verbose < 1)
        return;
    switch(Request) {
  case X_GLXQueryVersion:
    GLXQueryVersionReply(buf,n);
    break;
  case X_GLXMakeCurrent:
    GLXMakeCurrentReply(buf,n);
    break;
  case X_GLXIsDirect:
    GLXIsDirectReply(buf,n);
    break;
  case X_GLXGetVisualConfigs:
    GLXGetVisualConfigsReply(buf,n);
    break;
  case X_GLXVendorPrivateWithReply:
    GLXVendorPrivateWithReplyReply(buf,n);
    break;
  case X_GLsop_GenLists:
    GLXGenListsReply(buf,n);
    break;
  case X_GLsop_GetLightfv:
    GLXGetLightfvReply(buf,n);
    break;
  case X_GLsop_GetLightiv:
    GLXGetLightivReply(buf,n);
    break;
  case X_GLsop_GetMapdv:
    GLXGetMapdvReply(buf,n);
    break;
  case X_GLsop_GetMapfv:
    GLXGetMapfvReply(buf,n);
    break;
  case X_GLsop_GetMapiv:
    GLXGetMapivReply(buf,n);
    break;
  case X_GLsop_GetMaterialfv:
    GLXGetMaterialfvReply(buf,n);
    break;
  case X_GLsop_GetMaterialiv:
    GLXGetMaterialivReply(buf,n);
    break;
  case X_GLsop_GetPixelMapfv:
    GLXGetPixelMapfvReply(buf,n);
    break;
  case X_GLsop_GetPixelMapuiv:
    GLXGetPixelMapuivReply(buf,n);
    break;
  case X_GLsop_GetPixelMapusv:
    GLXGetPixelMapusvReply(buf,n);
    break;
  case X_GLsop_GetTexEnvfv:
    GLXGetTexEnvfvReply(buf,n);
    break;
  case X_GLsop_GetTexEnviv:
    GLXGetTexEnvivReply(buf,n);
    break;
  case X_GLsop_GetTexGendv:
    GLXGetTexGendvReply(buf,n);
    break;
  case X_GLsop_GetTexGenfv:
    GLXGetTexGenfvReply(buf,n);
    break;
  case X_GLsop_GetTexGeniv:
    GLXGetTexGenivReply(buf,n);
    break;
  case X_GLsop_GetTexParameterfv:
    GLXGetTexParameterfvReply(buf,n);
    break;
  case X_GLsop_GetTexParameteriv:
    GLXGetTexParameterivReply(buf,n);
    break;
  case X_GLsop_GetTexLevelParameterfv:
    GLXGetTexLevelParameterfvReply(buf,n);
    break;
  case X_GLsop_GetTexLevelParameteriv:
    GLXGetTexLevelParameterivReply(buf,n);
    break;
  case X_GLsop_IsEnabled:
    GLXIsEnabledReply(buf,n);
    break;
  case X_GLsop_IsList:
    GLXIsListReply(buf,n);
    break;
  case X_GLsop_Finish:
    GLXFinishReply(buf,n);
    break;
  case X_GLsop_GetBooleanv:
    GLXGetBooleanvReply(buf,n);
    break;
  case X_GLsop_GetClipPlane:
    GLXGetClipPlaneReply(buf,n);
    break;
  case X_GLsop_GetDoublev:
    GLXGetDoublevReply(buf,n);
    break;
  case X_GLsop_GetError:
    GLXGetErrorReply(buf,n);
    break;
  case X_GLsop_GetFloatv:
    GLXGetFloatvReply(buf,n);
    break;
  case X_GLsop_GetIntegerv:
    GLXGetIntegervReply(buf,n);
    break;
  case X_GLsop_GetString:
    GLXGetStringReply(buf,n);
    break;
  case X_GLsop_RenderMode:
    GLXRenderModeReply(buf,n);
    break;
  case X_GLsop_GetPolygonStipple:
    GLXGetPolygonStippleReply(buf,n);
    break;
  case X_GLsop_GetTexImage:
    GLXGetTexImageReply(buf,n);
    break;
  case X_GLsop_ReadPixels:
    GLXReadPixelsReply(buf,n);
    break;
    }
}
